<template>
    <div class="setting-drawer">
        <q-drawer
            v-model="settingDrawer"
            side="right"
            :width="300"
            overlay
            elevated
            :no-swipe-open="true"
        >
            <div class="row items-center justify-end col-12">
                <q-btn
                    class="q-px-md"
                    flat
                    text-color="black"
                    size="md"
                    icon="clear"
                    @click="closeDrawer(false)"
                />
            </div>
            <select-filter
                class="row items-center"
                :header="`Branch`"
                :branchData="business?.branches"
                :selectedBranch="state.selectedBranch"
                :reset="state.reset"
                @update-confirm="updateBranch"
            />
            <q-tabs
                v-model="tab"
                class="items-center headerTabs"
                active-color="none"
                dense
                indicator-color="transparent"
                align="center"
                narrow-indicator
                vertical
            >
                <!-- Chatting Pool -->
                <q-tab
                    class="row justify-center tab-menu items-center"
                    flat
                    no-caps
                    name="chatting"
                    :label="$t('home.chats')"
                    items-center
                    @click="selectTab('chatting')"
                />

                <!-- Ongoing -->
                <q-tab
                    class="row justify-center tab-menu items-center"
                    flat
                    no-caps
                    name="ongoing"
                    :label="$t('home.ongoing')"
                    items-center
                    @click="selectTab('ongoing')"
                />

                <!-- All Clients -->
                <q-tab
                    class="row justify-center tab-menu items-center"
                    flat
                    no-caps
                    name="clients"
                    :label="$t('home.clients')"
                    items-center
                    @click="selectTab('clients')"
                />

                <!-- Appointments -->
                <q-tab
                    class="row justify-center tab-menu items-center"
                    flat
                    no-caps
                    name="appointments"
                    :label="$t('home.appointments')"
                    items-center
                    @click="selectTab('appointments')"
                />
            </q-tabs>
        </q-drawer>
    </div>
</template>

<script lang="ts">
import { useStore } from 'src/store';
import {
    defineComponent,
    ref,
    computed,
    reactive,
    onMounted,
    watch
} from 'vue';
import { mapGetters } from 'vuex';
import { useRouter } from 'vue-router';
import localForage from 'localforage';
import { debounce } from 'lodash';
import SelectFilter from 'src/components/chats/SelectFilter.vue';

export default defineComponent({
    name: 'SettingDrawer',
    components: {
        SelectFilter
    },
    computed: {
        ...mapGetters({
            business: 'business/getBusiness',
            settingDrawer: 'menu/getSettingDrawer'
        })
    },
    setup() {
        const store = useStore();
        const router = useRouter();
        const branchStore = localForage.createInstance({
            name: 'lobbi/branch'
        });
        let state = reactive({
            branchList: computed(() => {
                return store.state.branch.branches;
            }),
            selectedBranch: {} as any,
            reset: ref(false)
        });

        const selectedBusinessId = computed(() => {
            return store.state.business.businessID;
        });

        const setSelectedBranch = () => {
            state.selectedBranch = store.state.branch.branch;
        };
        const checkPermission = () => {
            if (!store.state.role.permissions.conversation?.list) {
                router.push('/');
            }
        };
        const updateBranch = (currentValue: any) => {
            const findIndex = state.branchList.findIndex(
                (element: any) => element.id == currentValue.id
            );
            if (findIndex != -1) {
                branchStore.getItem('branchFilter').then(function (value: any) {
                    value.forEach((element: any) => {
                        if (element.businessId == selectedBusinessId.value) {
                            element.index = findIndex;
                            element.branchId = currentValue.id;
                            branchStore.setItem('branchFilter', value);
                        }
                    });
                });
            }
            store.dispatch('branch/setBranch', currentValue);
        };

        const selectTab = debounce((page: string) => {
            router.push('/helpdesk');
            store.dispatch('menu/setSelectedShortcut', page);
            store.dispatch('conversation/clearSelectedConversationID');
            store.dispatch('chat/unselectConversation');
            store.dispatch('menu/setNoteDrawer', false);
            store.dispatch('menu/setSettingDrawer', false);
        }, 500);

        const closeDrawer = (status: boolean) => {
            store.dispatch('menu/setSettingDrawer', status);
        };

        // watch
        watch(selectedBusinessId, () => {
            if (selectedBusinessId.value) {
                // check permission
                checkPermission();

                // set selected branch object
                setSelectedBranch();
            }
        });

        onMounted(checkPermission);
        onMounted(setSelectedBranch);

        return {
            state,
            updateBranch,
            selectTab,
            closeDrawer
        };
    }
});
</script>
